<?php

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

require_once __DIR__ . '/../../lib/bootstrap.php';

  require_once '/home/bbqpel5/public_html/bbqpelletsonline/automation' . '/vendor/autoload.php';
  require_once '/home/bbqpel5/public_html/bbqpelletsonline/automation' . '/configuration/api_config.php';
  require_once '/home/bbqpel5/public_html/bbqpelletsonline/automation' . '/public_html/quoting/class.taxjar.php';

  if(isset($_POST["action"]) && $_POST["action"] == "inactive_user" && isset($_POST["customerid"])){
        $return = array();
        $return['success'] = true;
        
        $dbc->newInsertExtraInfo($_POST['customerid'], 'inactive_user', 1);
        echo json_encode($return);
        exit;
  }
  if (isset($_POST['action'], $_POST['zip'], $_POST['city'], $_POST['state'], $_POST['customerid'], $_POST['street']) && $_POST['action'] === 'calc_taxes') {
    $return = array();
    $return['success'] = true;

    $client = TaxJar\Client::withApiKey(TAXJAR_API_KEY);

    $rates = $client->ratesForLocation($_POST['zip'], [
        'city' => $_POST['city'],
        'state' => $_POST['state'],
        'country' => 'US',
        'street' => $_POST['street']
    ]);
    $taxRateInfo = TaxJar::customOverride($rates);

    $taxrate = (float)$taxRateInfo['combined_rate'] * 100;

    $dbc->newInsertExtraInfo($_POST['customerid'], 'tax_rate', (string)$taxrate);

    echo json_encode($return);
    exit;
  }

if (isset($_POST['type']) && $_POST['type'] === 'res_liftgate') {
  if (isset($_POST['customer_id'])) {
    $customerID = $_POST['customer_id'];

    // add to PC bucket and current year bucket
    $bucketsToAdd = array(
        'PC',
        date("Y"), // current year (IE, 2018),
    );

    $bucketIDsToAdd = array();
    foreach ($bucketsToAdd as $bucket) {
      $b = $dbc->getBucketByName($bucket);
      $bid = $b['bucket_id'];
      $bucketIDsToAdd[] = $bid;
    }

    $dbc->insertCustomerBuckets($customerID, $bucketIDsToAdd, false);

    // remove from abandoned cart bucket
    $dbc->removeCustomerBuckets($customerID, array(3, 4));

    // set delivered to delivery address
    $dbc->newInsertExtraInfo($customerID, 'deliver_pickup_at_terminal_or_factory', 'Delivered to Delivery Address');

    // set customer type to individual
    $dbc->newInsertExtraInfo($customerID, 'customer_type', 'Individuals');

    // set delivery to residential
    $dbc->newInsertExtraInfo($customerID, 'delivery_type', 'Residential');

    // set liftgate to no
    $dbc->newInsertExtraInfo($customerID, 'have_forklift_or_loading_dock', 'No');

    // set num_tons to 1
    $dbc->newInsertExtraInfo($customerID, 'num_tons', '1');

    // set contact periodicity to 90
    $dbc->newInsertExtraInfo($customerID, 'contact_periodicity', '90');

    // set call ahead to no
    $dbc->newInsertExtraInfo($customerID, 'call_ahead', 'No');

    // set delivery appointment to no
    $dbc->newInsertExtraInfo($customerID, 'delivery_appt', 'No');

    exit;
  }
  exit;
}

  if (isset($_POST['type']) && $_POST['type'] === 'comm_fork') {
    if (isset($_POST['customer_id'])) {
      $customerID = $_POST['customer_id'];

      // add to PC bucket and current year bucket
      $bucketsToAdd = array(
          'PC',
          date("Y"), // current year (IE, 2018),
          $_POST['customer_type'],
      );

      $bucketIDsToAdd = array();
      foreach ($bucketsToAdd as $bucket) {
        $b = $dbc->getBucketByName($bucket);
        $bid = $b['bucket_id'];
        $bucketIDsToAdd[] = $bid;
      }

      $dbc->insertCustomerBuckets($customerID, $bucketIDsToAdd, false);

      // remove from abandoned cart bucket
      $dbc->removeCustomerBuckets($customerID, array(3, 4));

      // set delivered to delivery address
      $dbc->newInsertExtraInfo($customerID, 'deliver_pickup_at_terminal_or_factory', 'Delivered to Delivery Address');

      // set customer type to individual
      $dbc->newInsertExtraInfo($customerID, 'customer_type', 'Individuals');

      // set delivery to commercial
      $dbc->newInsertExtraInfo($customerID, 'delivery_type', 'Commercial');

      // set liftgate to yes
      $dbc->newInsertExtraInfo($customerID, 'have_forklift_or_loading_dock', 'Yes');

      // set num_tons to 1
      $dbc->newInsertExtraInfo($customerID, 'num_tons', '1');

      // set contact periodicity to 90
      $dbc->newInsertExtraInfo($customerID, 'contact_periodicity', '90');

      // set call ahead to no
      $dbc->newInsertExtraInfo($customerID, 'call_ahead', 'No');

      // set delivery appointment to no
      $dbc->newInsertExtraInfo($customerID, 'delivery_appt', 'No');

      exit;
    }
    exit;
  }

if (isset($_POST['set-customer-info'])) {
    $array = [];
    $array['status'] = 1;

    $customerid = $_POST['customerid'];
    $cim_num_tons = $_POST['cim_num_tons'];
    $cim_shipping_customer_charged = $_POST['cim_shipping_customer_charged'];
    $cim_call_ahead = $_POST['cim_call_ahead'];
    $cim_delivery_appt = $_POST['cim_delivery_appt'];
    $cim_shipper_used = $_POST['cim_shipper_used'];

    if (isset($_POST['cim_set_num_tons'])) {
        $dbc->newInsertExtraInfo($customerid, 'num_tons', $cim_num_tons);
    }

    if (isset($_POST['cim_set_shipping_customer_charged'])) {
        $dbc->newInsertExtraInfo($customerid, 'shipping_customer_charged', $cim_shipping_customer_charged);
    }

    if (isset($_POST['cim_set_call_ahead'])) {
        $dbc->newInsertExtraInfo($customerid, 'call_ahead', $cim_call_ahead);
    }

    if (isset($_POST['cim_set_delivery_appt'])) {
        $dbc->newInsertExtraInfo($customerid, 'delivery_appt', $cim_delivery_appt);
    }

    if (isset($_POST['cim_set_shipper_used'])) {
        $dbc->newInsertExtraInfo($customerid, 'shipper_used', $cim_shipper_used);
    }

    echo json_encode($array);
    die;
}

if(!empty($_POST)){ 
	if(!empty($_POST['address_line_1']) && !empty($_POST['address_city']) && !empty($_POST['address_state']) && !empty($_POST['address_zip']) && !empty($_POST['address_country']))  {
	    $customerID = $_POST['customer_id'];
	    
    	if($_POST['address_type'] == 'billing'){
	        $if_active = $dbc->checkIfHaveActive($customerID, 'billing');	
	    }else if($_POST['address_type'] == 'delivery'){	    	
	        $if_active = $dbc->checkIfHaveActive($customerID, 'delivery');	
	    } else if($_POST['address_type'] == 'parcel'){
            $if_active = $dbc->checkIfHaveActive($customerID, 'parcel');
	    }
		if($if_active[0]["totalActive"] == 0){
		    $_POST["active"] = 1;
		}
	    $insert = $dbc->insertAddress($customerID, $_POST,$_POST['address_type']);
print_r($insert);die;
	    if($insert){
	    	if($_POST['address_type'] == 'billing'){
		    	$AddressesAll = $dbc->getCustomerAddresses($customerID, 'billing', false);
		        $if_active = $dbc->checkIfHaveActive($customerID, 'billing');	
		    }else if($_POST['address_type'] == 'delivery'){	    	
				$AddressesAll = $dbc->getCustomerAddresses($customerID, 'delivery', false);
		        $if_active = $dbc->checkIfHaveActive($customerID, 'delivery');	
		    } else if($_POST['address_type'] == 'parcel'){
		        $AddressesAll = $dbc->getCustomerAddresses($customerID, 'parcel', false);
		    }

		$html="";
 		foreach($AddressesAll as $key=>$billAll):  
	        if($billAll['active']==1){ $active = '<button class="btn btn-success">Default Address</button>';} else {$active ="<button class='btn btn-warning make_default' rel='".$_POST['address_type']."' addressID='".$billAll['address_id']."'>Make as Default Address</button>";}
	        $no = $key+1;

            if($_POST['address_type'] == 'parcel') {
                $coordinates = '';
            } else 
                $coordinates = "<p><b>Co-ordinates : </b>". $billAll['lat'] ." ," .$billAll['lng'] ."</p>";
            
	        $html  .= "<div class='address_row well'>               
                <h5> <b>Address ".$no."</b> <span><a href='./gb-locator.php?address=".urlencode($billAll['address_line_1'])."&city=".urlencode($billAll['address_city'])."&state=".urlencode($billAll['address_state'])."&zip=".urlencode($billAll['address_zip'])."' target='_BLANK' class='btn btn-default'>Locate GB</a>".$active."<button class=\"btn btn-danger pull-right\" id=\"delIndAddress\" rel=\"".$_POST['address_type']."\" addressID=\"".$billAll['address_id']."\">Delete Address</button></span></h5>
	            <p>". $billAll['address_company']."</p>
	            <p>". $billAll['address_line_1']." , ". $billAll['address_line_2']."</p>
	            <p>". $billAll['address_city'] ." , ". $billAll['address_state'] ." , ". $billAll['address_zip'] ."</p>
	            <p>". $billAll['address_country'] ."</p>
	            $coordinates
	        </div>";
       	endforeach;

	    	$array = [];
			$array['status'] = 1;
			$array['msg'] = 'New Address Added';
			$array['html'] = $html;
			$array['type'] = $_POST['address_type'];

			echo json_encode($array);
			die;
	    }
	   
	}
	else if (isset($_POST['default_email']) && $_POST['default_email']==1 && isset($_POST['emailid']) && isset($_POST['customerid'])) {
	    $html = "";
	    $array = [];

	    $dbc->markCustomerEmailAddressDefault($_POST['customerid'], $_POST['emailid']);

	    $array['status'] = true;

        echo json_encode($array);
        die;
    }
    else if (isset($_POST['delete_email']) && $_POST['delete_email']==1 && isset($_POST['emailid']) && isset($_POST['customerid']) && isset($_POST['defaultemail'])) {
        $html = "";
        $array = [];

        $emailAddresses = $dbc->getCustomerEmailAddresses($_POST['customerid']);
        $found = false;
        foreach ($emailAddresses as $email) {
            if ($email['customer_email'] == $_POST['defaultemail']) $found = true;
        }
        if (!$found) {
            $emailAddresses[] = array(
                'customer_email' => $_POST['defaultemail'],
            );
        }
        if (count($emailAddresses) == 1) {
            $array['status'] = false;

            echo json_encode($array);
            die;
        }

        $dbc->deleteCustomerEmailAddress($_POST['customerid'], $_POST['emailid']);

        $emailAddresses = $dbc->getCustomerEmailAddresses($_POST['customerid']);
        $found = false;
        foreach ($emailAddresses as $email) {
            if ($email['customer_email'] == $_POST['defaultemail']) $found = true;
        }
        if (!$found) {
            $emailAddresses[] = array(
                'customer_email' => $_POST['defaultemail'],
            );
        }

        if(empty($emailAddresses)){
            // should never be hit
            $html .= '<h4>No Email Address Found.</h4>';
        }
        else {
            foreach($emailAddresses as $email):
                $html .= '<div class="address_row well">';
                $html .= "{$email['customer_email']}";
                if ($email['customer_email'] == $_POST['defaultemail']) {
                    $html .= '<p class="text-success pull-right">Default Address</p>';
                } else {
                    $html .= "<span class='pull-right'><button class='markemaildefaultbtn btn btn-warning' data-emailid='{$email['email_address_id']}'>Mark as Default</button>";
                    $html .= "<button class='deleteemailbtn btn btn-danger' data-emailid='{$email['email_address_id']}'>Delete</button></span>";
                }
                $html .= '</div>';
                endforeach;
        }

        $array = [];
        $array['status'] = true;
        $array['html'] = $html;

        echo json_encode($array);
        die;
    } else if (isset($_POST['addemail']) && $_POST['addemail'] == 1 && isset($_POST['customer_id']) && isset($_POST['emailaddress']) && isset($_POST['defaultemail'])) {
        $html = "";
        $array = [];

        if ($_POST['emailaddress'] == $_POST['defaultemail']) {
            $array['status'] = 0;
            $array['msg'] = "Email address already exists for user";
            echo json_encode($array);
            die;
        }

        $emailAddresses = $dbc->getCustomerEmailAddresses($_POST['customer_id']);
        foreach ($emailAddresses as $email) {
            if ($email['customer_email'] == $_POST['emailaddress']) {
                $array['status'] = 0;
                $array['msg'] = "Email address already exists for user";
                echo json_encode($array);
                die;
            }
        }

        $dbc->insertCustomerEmailAddresses($_POST['customer_id'], $_POST['emailaddress']);

        $emailAddresses = $dbc->getCustomerEmailAddresses($_POST['customer_id']);
        $found = false;
        foreach ($emailAddresses as $email) {
            if ($email['customer_email'] == $_POST['defaultemail']) $found = true;
        }
        if (!$found) {
            $emailAddresses[] = array(
                'customer_email' => $_POST['defaultemail'],
            );
        }

        if(empty($emailAddresses)){
            // should never be hit
            $html .= '<h4>No Email Address Found.</h4>';
        }
        else {
            foreach($emailAddresses as $email):
                $html .= '<div class="address_row well">';
                $html .= "{$email['customer_email']}";
                if ($email['customer_email'] == $_POST['defaultemail']) {
                    $html .= '<p class="text-success pull-right">Default Address</p>';
                } else {
                    $html .= "<span class='pull-right'><button class='markemaildefaultbtn btn btn-warning' data-emailid='{$email['email_address_id']}'>Mark as Default</button>";
                    $html .= "<button class='deleteemailbtn btn btn-danger' data-emailid='{$email['email_address_id']}'>Delete</button></span>";
                }
                $html .= '</div>';
            endforeach;
        }

        $array = [];
        $array['status'] = 1;
        $array['html'] = $html;

        echo json_encode($array);
        die;
    }
    else if ((isset($_POST['action'])) && ($_POST['action'] == 'delete_customer')) {
      $ret = [];
      $customerid = $_POST['customerID'];
      if (!$customerid) { $ret['success'] = 0; echo json_encode($ret); die; }
      
      $sth = $dbc->getPDO()->prepare("delete from bbqpo_customers where customer_id = $customerid");
      if (!$sth->execute()) { $ret['success'] = 0; echo json_encode($ret); die; }
      
      $ret['success'] = 1;
      echo json_encode($ret);
      die;
    }else{
		$array = [];
		$array['status'] = 0;
		$array['msg'] = 'Please fill all fields';
		echo json_encode($array);
		die;

	}
}

if (!empty($_GET) && isset($_GET['update_column_active']) && $_GET['update_column_active'] == 1) {
	$update = $dbc->updateAddressActiveColumn($_GET['addressID'],$_GET['type'],$_GET['customerID']);

	if($_GET['type'] == 'billing'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'billing', false);
    }else if($_GET['type'] == 'delivery'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'delivery', false);
    } else if($_GET['type'] == 'parcel'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'parcel', false);
    }

	$html="";
	foreach($AddressesAll as $key=>$billAll):         
    if($billAll['active']==1){ $active = '<button class="btn btn-success">Default Address</button>';} else {$active ="<button class='btn btn-warning make_default' rel='".$_GET['type']."' addressID='".$billAll['address_id']."'>Make as Default Address</button>";}
    $no = $key+1;
    
    $html  .= "<div class='address_row well'>
        <h5> <b>Address ".$no."</b> <span><a href='./gb-locator.php?address=".urlencode($billAll['address_line_1'])."&city=".urlencode($billAll['address_city'])."&state=".urlencode($billAll['address_state'])."&zip=".urlencode($billAll['address_zip'])."' target='_BLANK' class='btn btn-default'>Locate GB</a>".$active."<button class=\"btn btn-danger pull-right\" id=\"delIndAddress\" rel=\"".$_GET['type']."\" addressID=\"".$billAll['address_id']."\">Delete Address</button></span></h5>          
        <p>". $billAll['address_company']."</p>
        <p>". $billAll['address_line_1']." , ". $billAll['address_line_2']."</p>
        <p>". $billAll['address_city'] ." , ". $billAll['address_state'] ." , ". $billAll['address_zip'] ."</p>
        <p>". $billAll['address_country']."</p>
        <p><b>Co-ordinates : </b>". $billAll['lat'] ." ," .$billAll['lng'] ."</p>
    </div>";
   	endforeach;

   	$array = [];
	$array['status'] = 1;
	$array['msg'] = 'New Address Added';
	$array['html'] = $html;
	$array['type'] = $_GET['type'];

	echo json_encode($array);
	die;
}
if(!empty($_GET) && isset($_GET['delete_addresses']) && $_GET['delete_addresses']==1){


	$delete = $dbc->deleteCustomerAddress($_GET['customerID'],$_GET['type']);
	

	if($_GET['type'] == 'billing'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'billing', false);
    }else if($_GET['type'] == 'delivery'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'delivery', false);
    } else if($_GET['type'] == 'parcel'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'parcel', false);
    }

	$html="";

        if(empty($AddressesAll)){
            $html .= "<h4>No ".$_GET['type']." Address Found.</h4>";
        }
        


	foreach($AddressesAll as $key=>$billAll):         
 
    if($billAll['active']==1){ $active = '<button class="btn btn-success">Default Address</button>';} else {$active ="<button class='btn btn-warning make_default' rel='".$_GET['type']."' addressID='".$billAll['address_id']."'>Make as Default Address</button>";}

    $no = $key+1;

    $html  .= "<div class='address_row well'>               
        <h5> <b>Address ".$no."</b> <span><a href='./gb-locator.php?address=".urlencode($billAll['address_line_1'])."&city=".urlencode($billAll['address_city'])."&state=".urlencode($billAll['address_state'])."&zip=".urlencode($billAll['address_zip'])."' target='_BLANK' class='btn btn-default'>Locate GB</a>".$active."<button class=\"btn btn-danger pull-right\" id=\"delIndAddress\" rel=\"".$_GET['type']."\" addressID=\"".$billAll['address_id']."\">Delete Address</button></span></h5>
        <p>". $billAll['address_company']."</p>
        <p>". $billAll['address_line_1']." , ". $billAll['address_line_2']."</p>
        <p>". $billAll['address_city'] ." , ". $billAll['address_state'] ." , ". $billAll['address_zip'] ."</p>
        <p>". $billAll['address_country']."</p>
        <p><b>Co-ordinates : </b>". $billAll['lat'] ." ," .$billAll['lng'] ."</p>
    </div>";
   	endforeach;

   	$array = [];
	$array['status'] = 1;
	$array['msg'] = 'Delete All Addresses';
	$array['html'] = $html;
	$array['type'] = $_GET['type'];

	echo json_encode($array);
	die;

}

if(!empty($_GET) && isset($_GET['delete_individual_address']) && $_GET['delete_individual_address']==1 && isset($_GET['address_id'])){


    $delete = $dbc->deleteIndividualCustomerAddress($_GET['customerID'],$_GET['type'],$_GET['address_id']);

    if($_GET['type'] == 'billing'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'billing', false);
    }else if($_GET['type'] == 'delivery'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'delivery', false);
    } else if($_GET['type'] == 'parcel'){
        $AddressesAll = $dbc->getCustomerAddresses($_GET['customerID'], 'parcel', false);
    }

    $html="";

    if(empty($AddressesAll)){
        $html .= "<h4>No ".$_GET['type']." Address Found.</h4>";
    }



    foreach($AddressesAll as $key=>$billAll):

        if($billAll['active']==1){ $active = '<button class="btn btn-success">Default Address</button>';} else {$active ="<button class='btn btn-warning make_default' rel='".$_GET['type']."' addressID='".$billAll['address_id']."'>Make as Default Address</button>";}

        $no = $key+1;

        $html  .= "<div class='address_row well'>               
        <h5> <b>Address ".$no."</b> <span><a href='./gb-locator.php?address=".urlencode($billAll['address_line_1'])."&city=".urlencode($billAll['address_city'])."&state=".urlencode($billAll['address_state'])."&zip=".urlencode($billAll['address_zip'])."' target='_BLANK' class='btn btn-default'>Locate GB</a>".$active."<button class=\"btn btn-danger pull-right\" id=\"delIndAddress\" rel=\"".$_GET['type']."\" addressID=\"".$billAll['address_id']."\">Delete Address</button></span></h5>
        <p>". $billAll['address_company']."</p>
        <p>". $billAll['address_line_1']." , ". $billAll['address_line_2']."</p>
        <p>". $billAll['address_city'] ." , ". $billAll['address_state'] ." , ". $billAll['address_zip'] ."</p>
        <p>". $billAll['address_country']."</p>
        <p><b>Co-ordinates : </b>". $billAll['lat'] ." ," .$billAll['lng'] ."</p>
    </div>";
    endforeach;

    $array = [];
    $array['status'] = 1;
    $array['msg'] = 'Delete Individual Address';
    $array['html'] = $html;
    $array['type'] = $_GET['type'];

    echo json_encode($array);
    die;

}

?>
