<?php

require_once __DIR__ . '/../../lib/bootstrap.php';

header("Content-type: application/json");

register_shutdown_function('jsonExit');

function jsonExit() {
    global $toReturn;
    $debug = ob_get_contents();
    if (defined('RETURN_DEBUG') and (RETURN_DEBUG === true)) {
        $toReturn['debug'] = $debug;
    }
    echo json_encode($toReturn, JSON_PRETTY_PRINT);
    exit();
}

$toReturn = array();

/*
You will get 'pk', 'name' and 'value' in $_POST array.
*/
$pk = $_POST['pk'];
$name = $_POST['name'];
$value = $_POST['value'];
$table = $_POST['table'];
$customerID = $_POST['customerID'];

$needsCreated = false;
if (isset($_POST['needs_created'])) {
    $needsCreated = true;
}

$toReturn['request_values'] = $_POST;

if ($table == 'customer') {
    $toReturn['table_type'] = 'customer';
    if ($dbc->updateCustomer($pk, $name, $value)) {
        $dbc->update_templates($customerID);
        $toReturn['success'] = true;
        exit();
    }
    else {
        errorExit("Could not update customer table field `{$name}` to '{$value}'");
    }
}
elseif ($table == 'address') {
    $toReturn['table_type'] = 'address';
    
    
    if ($name == 'address_zip') {
        $updateResult = $dbc->updateAddress($pk, $name, $value, true);
        //sleep(1);
        $newValueRows = $dbc->getCustomerAddress($pk);
        
        if (!empty($newValueRows['county_tag'])) {
            $toReturn['new_county_tag'] = $newValueRows['county_tag'];
            
        }
        $toReturn['success'] = $updateResult;
        exit();
        
    }
    else if ($dbc->updateAddress($pk, $name, $value)) {
        
        $toReturn['success'] = true;
        exit();
    }
    else {
        errorExit("Could not update address table field `{$name}` to '{$value}'");
    }
}
elseif ($table == 'extra_info') {


    $toReturn['table_type'] = 'extra_info';
    
    $existingRow = $dbc->existOrNotCustomerExtraInfoRows($customerID, $name, false);
    $needsCreated = empty($existingRow);
    if ($needsCreated) {
        if ($newExtraInfoID = $dbc->insertExtraInfo($customerID, $name, $value)) {
            $toReturn['success2'] = true;
            $toReturn['new_id'] = $newExtraInfoID;
            $dbc->update_templates($customerID);
            exit();
        }
        else {
            errorExit("Could not create `{$name}` in extra_info table!");
        }
    }
    else {
        //if ($dbc->updateExtraInfo($pk, $name, $value)) {
        if ($dbc->updateExtraInfoByCustomerID($customerID, $name, $value)) {
            $toReturn['success1'] = true;
            $dbc->update_templates($customerID);
            exit();
        }
        else {
            errorExit("Could not update extra_info table field `{$name}` to '{$value}'");
        }
    }
}


function errorExit($errorMessage) {
    global $toReturn;
    $toReturn['error'] = true;
    $toReturn['success'] = false;
    $toReturn['message'] = $errorMessage;
    header('HTTP/1.0 400 Bad Request', true, 400);
    exit();
}
