<?php

require_once __DIR__ . '/../../lib/bootstrap.php';
require_once __DIR__ . '/../../lib/class.breezingformshelper.php';
BreezingFormsImporterHelper::init();

$customerID = $_POST["customer_id"];
$dataToSend = '';
if($customerID){
    
    $from_date = $_POST["start_date"];
    $to_date = $_POST["end_date"];
    
    if(!empty($from_date) || !empty($to_date)){
        $customerOrdersHistory = $dbc->getShippingEasyOrdersByCustomerANDDate($customerID,$from_date,$to_date);
    }
    else{
        $customerOrdersHistory = $dbc->getShippingEasyOrdersByCustomer($customerID);
    }

   $orderCount = 0;
   foreach($customerOrdersHistory as $order) {
        if ($order['store_ordered_from'] != 'Freshbooks') { continue; }
        $jsonobj = json_decode($order['se_api_response'], true);
        if($order["order_id"] > 82206){
        $lineitems = $jsonobj['lines'];            
        }
        else{
        $lineitems = $jsonobj['lines']['line'];            
        }

        $deliverycharge = 0;
        $shipper = "";
        $callahead = "No";
        $appointment = "No";
        $array_item_name = [];
        foreach ($lineitems as $lineitem) {
           if(stripos(@$lineitem['name'],"1T(20#)-") !== false){
               $array_item_name["1T(20#)"][] = str_replace("1T(20#)-","",$lineitem['name']);
           }
           if(stripos(@$lineitem['name'],"1T(40#)-") !== false){
               $array_item_name["1T(40#)"][] = str_replace("1T(20#)-","",$lineitem['name']);
           }

           if(stripos(@$lineitem['name'],"1/2T(20#)-") !== false){
               $array_item_name["1/2T(20#)"][] = str_replace("1/2T(20#)-","",$lineitem['name']);
           }
           if(stripos(@$lineitem['name'],"1/2T(40#)-") !== false){
               $array_item_name["1/2T(40#)"][] = str_replace("1/2T(40#)-","",$lineitem['name']);
           }         
           
           if(stripos(@$lineitem['name'],"1/4T(20#)-") !== false){
               $array_item_name["1/4T(20#)"][] = str_replace("1/4T(20#)-","",$lineitem['name']);
           }
           if(stripos(@$lineitem['name'],"1/4T(40#)-") !== false){
               $array_item_name["1/4T(40#)"][] = str_replace("1/4T(40#)-","",$lineitem['name']);
           }                    

           if (@$lineitem['name'] == 'Call-Ahead') { $callahead = "Yes"; }
           if (@$lineitem['name'] == 'Appointment') { $appointment = "Yes"; }
           if (@$lineitem['name'] !== "Delivery") { continue; }
           $shipper = $lineitem['description'];
           $shipping_method = $lineitem['description'];
           $shipper = preg_replace("/^Delivery - /", "", $shipper);
           $shipper = preg_replace("/ \(.*/", "", $shipper);
           $shipper = trim($shipper);
            if($order["order_id"] > 82206){
                $deliverycharge = $lineitem['amount']['amount'];
            }
            else{
                $deliverycharge = $lineitem['amount'];
            }           
           break;
        }
       
        $bbqpoChargedAmount = 'Unknown';
        $freshbooksInvoiceID = trim($order['store_order_id']);
        
        $bfFormIDs = BreezingFormsImporterHelper::findRecordByValue($freshbooksInvoiceID, BreezingFormsImporterHelper::GLRE_FORM_NUMBER);
        if (!empty($bfFormIDs)) {
            $bfFormID = $bfFormIDs[0];
            BreezingFormsImporterHelper::setRecordID($bfFormID);
            $bbqpoChargedAmount = BreezingFormsImporterHelper::ff_getSubmit('shipping_bbqpo');
        }
        $label = "";
        // echo "<pre>";
        // print_r($array_item_name);die;
        foreach($array_item_name as $key => $value){
            $label .= $key."(".implode(" - ",$value).").<hr>";
        }
        

        $dataToSend .= "<tr>
            <td>".$order['store_order_id']."</td>
            <td>".date('m-d-Y', strtotime($order['ordered_time']))."</td>
            <td>".$shipping_method."</td>
            <td>".$deliverycharge."</td>
            <td>".$bbqpoChargedAmount."</td>
            <td>".calculateFreshbooksTotalWeight(json_decode($order['se_api_response'], true))." lbs</td>
            <td><a href='https://my.freshbooks.com/#/invoice/aOOXk-".$order['se_order_id']."' target='_BLANK'>Freshbooks</a></td>
            <td>
                <button class='btn btn-default setcustomerinfobtn' data-num_tons='". calculateFreshbooksTotalWeight(json_decode($order["se_api_response"], true))/2000 ."' data-shipping_customer_charged='$deliverycharge' data-shipping_bbqpo_charged='$bbqpoChargedAmount' data-call_ahead='$callahead' data-delivery_appt='$appointment' data-shipper_used='$shipper'>Set Customer Info</button>
            </td>
            <td>
                <a href='javascript:void(0)' data-id='".$order['se_order_id']."' class='showPopUpInvoice'>Show Invoice</a>
            </td>
            <td>
            $appointment
            </td>
            <td>
            $callahead
            </td>
            <td>
            $label
            </td>
        </tr>";
        $orderCount++;
        
   }
   
   if ($orderCount == 0) {
       echo "<tr>
                <td colspan=100 class='text-center'><em>No Order History</em></td>
            </tr>";
   }
   else{
       echo $dataToSend;   
   }
}

?>

