<?php

require_once __DIR__ . '/lib/bootstrap.php';

header("Content-type: application/json");

register_shutdown_function('jsonExit');

function jsonExit() {
    global $toReturn;
    $debug = ob_get_contents();
    if (defined('RETURN_DEBUG') and (RETURN_DEBUG === true)) {
        $toReturn['debug'] = $debug;
    }
    echo json_encode($toReturn, JSON_PRETTY_PRINT);
    exit();
}
$toReturn = array();

$customerID = $_POST['customerID'];
$extraInfoRows = $dbc->getCustomerExtraInfoRows($customerID, true);
$pellet_order_descriptions = $dbc->getPelletOrderDescription();



$extraInfo = array();
$combine_array=array();

foreach($extraInfoRows as $row) {
    $key = $row['extra_info_key'];
    $value = $row['extra_info_value'];
    $row['value'] = $value;    
    $extraInfo[$key] = $row; //$value;
}


foreach ($pellet_order_descriptions as $key => $value) {
   // echo $extraInfo[$value['sku']];
    if($extraInfo[$value['sku']]){
        if ($dbc->updateExtraInfo($extraInfo[$value['sku']]['extra_info_id'], $extraInfo[$value['sku']]['extra_info_key'], '0')) {
            $toReturn['success1'] = true;
           // exit();
        }
        else {
            errorExit("Could not update extra_info table field `{$value['sku']}`");
        }
    }else{
        $pk = $customerID;
        if ($newExtraInfoID = $dbc->insertExtraInfo($pk, $value['sku'], '0')) {
            $toReturn['success2'] = true;
            $toReturn['new_id'] = $newExtraInfoID;
      
           // exit();
        }
        else {
            errorExit("Could not create `{$name}` in extra_info table!");
        }
    }
}







function errorExit($errorMessage) {
    global $toReturn;
    $toReturn['error'] = true;
    $toReturn['success'] = false;
    $toReturn['message'] = $errorMessage;
    header('HTTP/1.0 400 Bad Request', true, 400);
    exit();
}