<?php

require_once __DIR__ . '/../../lib/bootstrap.php';

header("Content-type: application/json");

register_shutdown_function('jsonExit');

function jsonExit() {
    global $toReturn;
    $debug = ob_get_contents();
    if (defined('RETURN_DEBUG') and (RETURN_DEBUG === true)) {
        $toReturn['debug'] = $debug;
    }
    echo json_encode($toReturn, JSON_PRETTY_PRINT);
    exit();
}

$toReturn = array();

/*
You will get 'pk', 'name' and 'value' in $_POST array.
*/
$customerID = $_POST['pk'];
$bucketID = $_POST['bucketID'];
$method = $_POST['method'];
$BUCKETS_MAP = $dbc->getAllBuckets();

if (empty($customerID)) {
    errorExit("No customer ID set!");
}
else if (empty($bucketID)) {
    errorExit("No bucket ID set!");
}
else if (empty($method)) {
    errorExit("No method set!");
}

switch ($method) {
    case 'DELETE':
        if($bucketID == 330){
            $dbc->removeUserTestBucket($customerID);
        }
        $toReturn['success'] = $dbc->removeCustomerBuckets($customerID, array($bucketID));
        $dbc->update_templates($customerID);
        exit();
        break;
    case 'CREATE_PRODUCT':
        $toReturn['success'] = $dbc->insertCustomerProductList($customerID, array($bucketID));
        $dbc->update_templates($customerID);
        if (in_array($bucketID, [$BUCKETS_MAP['AAA-Not Important'], $BUCKETS_MAP['ZZZ-Not Interested']])) {
            // set periodicity to empty
           
            $existingRow = $dbc->existOrNotCustomerExtraInfoRows($customerID, 'contact_periodicity', false);
            $needsCreated = empty($existingRow);
            if ($needsCreated) {
                if ($newExtraInfoID = $dbc->insertExtraInfo($customerID, 'contact_periodicity', '')) {
                    //exit();
                }
                else {
                    errorExit("Could not create `contact_periodicity` in extra_info table!");
                }
            }
            else {
                //if ($dbc->updateExtraInfo($pk, $name, $value)) {
                if ($dbc->updateExtraInfoByCustomerID($customerID, 'contact_periodicity', '')) {
                    //exit();
                }
                else {
                    errorExit("Could not update extra_info table field `contact_periodicity` to ''");
                }
            }
            // remove from all other buckets
            // getBucketsByCustomer
            // removeCustomerBuckets
            $customersBuckets = $dbc->getBucketsByCustomer($customerID);
            $bucketIDsToRemove = [];
            foreach($customersBuckets as $customerBucketRow) {
                $currentBucketID = $customerBucketRow['bucket_id'];
                if ($currentBucketID == $bucketID) {
                    continue;
                }
                $bucketIDsToRemove[] = $currentBucketID;
            } // foreach customersBuckets

            $dbc->removeCustomerBuckets($customerID, $bucketIDsToRemove);

            
 
        }
        exit();

    case 'CREATE':
        if($bucketID == 330){
            $dbc->addUserTestBucket($customerID);
        }
        $toReturn['success'] = $dbc->insertCustomerBuckets($customerID, array($bucketID), false);
        $dbc->update_templates($customerID);
        if (in_array($bucketID, [$BUCKETS_MAP['AAA-Not Important'], $BUCKETS_MAP['ZZZ-Not Interested']])) {
            // set periodicity to empty
           
            $existingRow = $dbc->existOrNotCustomerExtraInfoRows($customerID, 'contact_periodicity', false);
            $needsCreated = empty($existingRow);
            if ($needsCreated) {
                if ($newExtraInfoID = $dbc->insertExtraInfo($customerID, 'contact_periodicity', '')) {
                    //exit();
                }
                else {
                    errorExit("Could not create `contact_periodicity` in extra_info table!");
                }
            }
            else {
                //if ($dbc->updateExtraInfo($pk, $name, $value)) {
                if ($dbc->updateExtraInfoByCustomerID($customerID, 'contact_periodicity', '')) {
                    //exit();
                }
                else {
                    errorExit("Could not update extra_info table field `contact_periodicity` to ''");
                }
            }
            // remove from all other buckets
            // getBucketsByCustomer
            // removeCustomerBuckets
            $customersBuckets = $dbc->getBucketsByCustomer($customerID);
            $bucketIDsToRemove = [];
            foreach($customersBuckets as $customerBucketRow) {
                $currentBucketID = $customerBucketRow['bucket_id'];
                if ($currentBucketID == $bucketID) {
                    continue;
                }
                $bucketIDsToRemove[] = $currentBucketID;
            } // foreach customersBuckets

            $dbc->removeCustomerBuckets($customerID, $bucketIDsToRemove);

            
 
        }
        exit();
        break;
    default:
        errorExit("No method set!");
}


function errorExit($errorMessage) {
    global $toReturn;
    $toReturn['error'] = true;
    $toReturn['success'] = false;
    $toReturn['message'] = $errorMessage;
    header('HTTP/1.0 400 Bad Request', true, 400);
    exit();
}
