<?php
require_once __DIR__ . '/../../lib/bootstrap.php';
require_once __DIR__ . '/../../lib/class.breezingformshelper.php';
BreezingFormsImporterHelper::init();


$customers = $dbc->getCustomers();

foreach($customers as $customer){
    $customer_id = $customer["customer_id"];
    $customer_info = $dbc->getCustomer($customer_id);
    
    $bucket = $dbc->getBucketsByCustomer($customer_id);
    
    $getTemplates = $dbc->getMarketingTemplates();
    
    $contact_periodicity = ($customer_info["extra_info"]["contact_periodicity"]) ? $customer_info["extra_info"]["contact_periodicity"] : 0;  
    $customer_type       = ($customer_info["extra_info"]["customer_type"]) ? $customer_info["extra_info"]["customer_type"] : '';  
    
    
    $last_bbq_interaction_date = $customer_info["last_bbq_interaction_date"];
    $last_customer_interaction_date = $customer_info["last_customer_interaction_date"];
    $last_contact_date = $customer_info["last_contact_date"];
    
    if(!empty($last_bbq_interaction_date) && !empty($last_customer_interaction_date)){
        if(strtotime($last_bbq_interaction_date) > strtotime($last_customer_interaction_date)){
            $diff_date = $last_bbq_interaction_date;
        }
        else{
            $diff_date = $last_customer_interaction_date;
        }
    }
    elseif(empty($last_bbq_interaction_date) && !empty($last_customer_interaction_date)){
        $diff_date = $last_customer_interaction_date;
    }
    elseif(!empty($last_bbq_interaction_date) && empty($last_customer_interaction_date)){
        $diff_date = $last_bbq_interaction_date;
    }
    else{
        $diff_date = $last_contact_date;
    }
    
    $now = time(); // or your date as well
    $your_date = strtotime($diff_date);
    $datediff = $now - $your_date;
    
    $many_days =  round($datediff / (60 * 60 * 24));
    // if($many_days == 55 || $many_days == 85){
        
    // }
    
    
    $template = array();
    $templateName = array();
    $templateSubject = array();
    $templateBody = array();
    
    foreach($bucket as $bu){
        if($bu["bucket_name"] == "EC"){
            if($many_days > $contact_periodicity){
                if(trim(strtolower($customer_type)) == trim(strtolower("Mushroom Grower"))){
                     $templateName = "EC Mushroom";   
                }
                else{
                    $templateName = "HFQ";                    
                }
                break;
            }
            if($customer_type == 'Individual' || $customer_type == 'Smokehouse' || $customer_type == 'Other') {
                // if($many_days > $contact_periodicity) {
                    $templateName = $getTemplates[1]['template_name'];
                    $templateSubject = $getTemplates[1]['subject'];
                    $templateBody = $getTemplates[1]['body'];
                    break;
                // }
            }
            elseif($customer_type == 'Retailer') {
                // if($many_days > $contact_periodicity) {
                    $templateName = $getTemplates[2]['template_name'];
                    $templateSubject = $getTemplates[2]['subject'];
                    $templateBody = $getTemplates[2]['body'];
                    break;
                // }
            }
            elseif($customer_type == 'Restaurant/Caterer') {
                // if($many_days > $contact_periodicity) {
                    $templateName = $getTemplates[0]['template_name'];
                    $templateSubject = $getTemplates[0]['subject'];
                    $templateBody = $getTemplates[0]['body'];
                    break;
                // }
            }
        }
        elseif($bu["bucket_name"] == "PC") {
            
            if($customer_type == "Mushroom Grower"){
                // if($many_days > $contact_periodicity){
                    $templateName = "PC Mushroom";   
                // }
                    break;
            }
            elseif($customer_type == 'Individual' || $customer_type == 'Restaurant/Caterer' || $customer_type == 'Smokehouse' || $customer_type == 'Other') {
                // if($many_days > $contact_periodicity) {
                    $templateName = $getTemplates[5]['template_name'];
                    $templateSubject = $getTemplates[5]['subject'];
                    $templateBody = $getTemplates[5]['body'];
                    break;
                // }
            }
            elseif($customer_type == 'Retailer') {
                // if($many_days > $contact_periodicity) {
                    $templateName = $getTemplates[3]['template_name'];
                    $templateSubject= $getTemplates[3]['subject'];
                    $templateBody = $getTemplates[3]['body'];
                    break;
                // }
            }
            
        }
    }

    if(!empty($templateName)){
        //  $dbc->insertExtraInfo($customer_id,'drip_type',$templateName);
        //  $dbc->updateCustomerTemplate($customer_id, $templateName);
    }
}

?>